#Setting Up the CameraView
class CameraLayer extends Layer
	
	constructor: (options) ->
		super options
		
  
		@_video = document.createElement("video")
		@_canvas = document.createElement("canvas")
		@_canvas.setAttribute("width", @width)
		@_canvas.setAttribute("height", @height)		
		@_ctx = @_canvas.getContext("2d")
		
		@_video.setAttribute("width", @width)
		@_video.setAttribute("height", @height)
		@_video.setAttribute("autoplay", @autoplay)

		@_element.appendChild(@_video)
		videoSources = []
		isfront = false
		vprint = (e) ->
			if videoSources.length > 1
				start(videoSources[1])
				
				switchbtn.opacity = 1
				switchbtn.on Events.Click,->
					switchbtn.scale = 0.4
					switchbtn.animate
						properties:
							scale:0.6
						curve:'spring(50,12,0)'
					if isfront is false
						start(videoSources[0])
						isfront = true	
					else
						start(videoSources[1])
						isfront = false
			else
				start(videoSources[0])
			

		gotSources = (sourceInfos) ->
			for i in [0...sourceInfos.length]	
				
				sourceInfo = sourceInfos[i]
				
				if sourceInfo.kind is 'video'
					videoSources.push(sourceInfo)
				else
					console.log "audio", sourceInfo
				if i == sourceInfos.length-1
					vprint(videoSources)
					
		
		if typeof MediaStreamTrack is 'undefined'
		else
			MediaStreamTrack.getSources(gotSources)
		
		successCallback = (stream) ->
			window.stream = stream
			@_myvideo = document.querySelector("video")
			@_myvideo.src = window.URL.createObjectURL(stream)
			@_myvideo.addEventListener 'playing', ->
				Utils.delay 0.3,-> console.log @_myvideo.videoWidth + 'x' + @_myvideo.videoHeight
			
		errorCallback = (error) ->
			
			print "error", error
		
		start = (e) ->
			if !!window.stream
			    @_myvideo.src = null
			    window.stream.stop()
			videoSource = e.id
			constraints = 
				video: 
					optional: [{sourceId: videoSource}]
			navigator.getUserMedia(constraints,successCallback,errorCallback)
			
		if navigator.webkitGetUserMedia
			navigator.getUserMedia = navigator.webkitGetUserMedia || navigator.getUserMedia || navigator.mozGetUserMedia
			
		else
			console.log "not supported"	
							
		#Capture Function, Returns Canvas	
		@capture = () ->
			
			@_ctx.drawImage(@_video,0,0,1280,960)
			
			return @_canvas

#Basic Layer Setup


dwidth = Framer.Screen.width
dheight = Framer.Screen.height

cameraview = new CameraLayer
	x:0, y:0, width:dwidth,height:dheight,backgroundColor:'#000'

cameraroll = new Layer width:dwidth, height:dwidth*.75,backgroundColor:''
#Event Toggle
captured = ->
	cameraview.animateStop()
				
	cameraview.brightness = 200
	cameraview.animate
		properties:
			brightness:100
		curve:'spring(500,50,0)'
	
	capturedcanavs = cameraview.capture()
	captureview.image = capturedcanavs.toDataURL('image/webp')

camerabtn = new Layer width:dwidth, height:dheight/7,backgroundColor:'#333'
camerabtn.y = dheight-camerabtn.height

btncheck = new Layer x:0, y:camerabtn.height/4, width:325*0.2, height:244*0.2, image:"images/btn-check.png",superLayer:camerabtn
btncheck.centerX()

switchbtn = new Layer width:102*0.5,height:66*0.5,image:'images/switch.png',superLayer:camerabtn
switchbtn.x = camerabtn.width/1.2
switchbtn.y = camerabtn.height/3
switchbtn.opacity = 1
captureview = new Layer x:dwidth*0.05,y:camerabtn.height/5,width:dwidth*0.11, height:dwidth*0.1,superLayer:camerabtn,backgroundColor:'#000'

btncheck.on Events.Click,->
	
	captured()