#Setting Up the CameraView
class CameraLayer extends Layer
	
	constructor: (options) ->
		super options
		
  
		@_video = document.createElement("video")
		@_canvas = document.createElement("canvas")
		@_canvas.setAttribute("width", @width)
		@_canvas.setAttribute("height", @height)		
		@_ctx = @_canvas.getContext("2d")
		
		@_video.setAttribute("width", @width)
		@_video.setAttribute("height", @height)
		@_video.setAttribute("autoplay", @autoplay)

		@_element.appendChild(@_video)
		videoSources = []
		isfront = false
		vprint = (e) ->
			if videoSources.length > 1
				start(videoSources[1])
				switchbtn = new Layer width:102,height:66,image:'images/switch.png',superLayer:camerabtn

				switchbtn.x = camerabtn.width/1.4
				switchbtn.y = camerabtn.height/4
				switchbtn.scale = 0.4
				switchbtn.on Events.Click,->
					switchbtn.animate
						properties:
							scale:1
						curve:'spring(50,12,0)'
					if isfront is false
						start(videoSources[0])
						isfront = true	
					else
						start(videoSources[1])
						isfront = false
			else
				start(videoSources[0])
			

		gotSources = (sourceInfos) ->
			for i in [0...sourceInfos.length]	
				
				sourceInfo = sourceInfos[i]
				
				if sourceInfo.kind is 'video'
					videoSources.push(sourceInfo)
				else
					console.log "audio", sourceInfo
				if i == sourceInfos.length-1
					vprint(videoSources)
					
		
		if typeof MediaStreamTrack is 'undefined'
		else
			MediaStreamTrack.getSources(gotSources)
		
		successCallback = (stream) ->
			window.stream = stream
			@_myvideo = document.querySelector("video")
			@_myvideo.src = window.URL.createObjectURL(stream)
			@_myvideo.addEventListener 'playing', ->
				Utils.delay 0.3,-> console.log @_myvideo.videoWidth + 'x' + @_myvideo.videoHeight
			
		errorCallback = (error) ->
			
			print "error", error
		
		start = (e) ->
			if !!window.stream
			    @_myvideo.src = null
			    window.stream.stop()
			if e.facing is "environment"
				vidwidth = 720
				vidHeight = 1280
			videoSource = e.id
			constraints = 
				video: 
					optional: [{sourceId: videoSource}]
			navigator.getUserMedia(constraints,successCallback,errorCallback)
			
		if navigator.webkitGetUserMedia
			navigator.getUserMedia = navigator.webkitGetUserMedia || navigator.getUserMedia || navigator.mozGetUserMedia
			
		else
			console.log "not supported"	
							
		#Capture Function, Returns Canvas	
		@capture = () ->
			
			@_ctx.drawImage(@_video,0,0,1280,960)
			
			return @_canvas

#Basic Layer Setup

dwidth = 720
dheight = 1280


container = new Layer width:dwidth,height:dheight,backgroundColor:'#333'

container.scale = 0.5
container.center()

cameraview = new CameraLayer
	x:0, y:-200, width:dwidth,height:dheight,backgroundColor:''

cameraroll = new Layer width:dwidth, height:dwidth*.75,backgroundColor:''

#Event Toggle
captured = ->
	cameraview.animateStop()
	captureview = new Layer x:0,width:dwidth, height:dheight,backgroundColor:'',superLayer:cameraroll		
	cameraroll.x = 0
	cameraroll.y = 0
	
	cameraroll.animate
		properties:
			x:dwidth*0.8
			y:dheight*0.3
			scale:0.2
		curve:'spring(50,12,0)'
	
	cameraview.scale = 0.9
	cameraview.animate
		properties:
			scale:1
		curve:'spring(500,50,0)'
	
	capturedcanavs = cameraview.capture()
	captureview.image = capturedcanavs.toDataURL('image/webp')
# 	captureview.x = dwidth/5
# 	captureview.rotationZ = 0
# 	captureview.animate
# 		properties:
# 			x:dwidth
# 			rotationZ:10
# 		curve:'spring(100,12,0)'

camerabtn = new Layer width:dwidth, height:dheight/6,backgroundColor:''
camerabtn.y = dheight-camerabtn.height

btncheck = new Layer 
	x:0, y:0, width:325, height:244, image:"images/btn-check.png",superLayer:camerabtn
btncheck.scale = 0.3
btncheck.centerX()

container.addSubLayer(cameraview)
container.addSubLayer(cameraroll)
container.addSubLayer(camerabtn)

container.scale = 0.5

camerabtn.on Events.Click,->
	
	captured()